﻿/** ********************************************* **/
/** *              C O N T R O L S              * **/
/** ********************************************* **/

:root {

    --fill-color                          : var(--site__color-hilite);

    --controls__upload                    : url("../assets/images/upload.svg");
    --controls__arrowup                   : url("../assets/images/arrow-up.svg");
    --controls__arrowdown                 : url("../assets/images/arrow-down.svg");
    --controls__arrow-size                : 32px 32px;
    --controls__upload-size               : 45px 45px;
    --controls__arrow-position            : bottom 50% right 0;

    --controls__color                     : var(--site__color-dark);
    --controls__background-color          : var(--site__color-light);
    --controls__disabled-background-color : var(--color6);
    --controls__border-radius             : 0;

    --controls__case                      : none;

    --controls__font-size                 : 1.2rem;
    --controls__font                      : var(--fw-bold)   var(--controls__font-size)/2.4 var(--ff-regular);
    --controls__placeholder-font          : var(--fw-normal) var(--controls__font-size)/2.4 var(--ff-regular);
    --controls__dropdown-font             : var(--fw-normal) var(--controls__font-size)/2.4 var(--ff-dropdown);

	--controls__placeholder-opacity       : 1;

}

/** ********************************************* **/
/** * MISCELLANEOUS                             * **/
/** ********************************************* **/

.no-border {
    border          : none;
}

/** ********************************************* **/
/** * CONTAINERS                                * **/
/** ********************************************* **/

.grid-row {
    align-self      : center;
    justify-self    : left;
}

.row {
    display         : flex;
    align-items     : center;
    justify-content : left;
    gap             : 1rem;
}

.row-center,
.button-container {
    display         : flex;
    align-items     : center;
    justify-content : center;
    gap             : 1rem;
}


/** ********************************************* **/
/** LABELS                                        **/
/** ********************************************* **/

label {
	display          : inline;
    color            : var(--site__color-dark);
    font             : var(--fw-bold) 1.3rem/1.4 var(--ff-condensed);
    text-transform   : uppercase;
}


/** ********************************************* **/
/** LINK BUTTON AND ASP BUTTON                    **/
/** STYLED (PROMO) BUTTON                         **/
/** ********************************************* **/

button,
.aspbutton,
.promo-button,
.button-container a {
    font             : var(--fw-bold) 2rem/1 var(--ff-condensed);
    text-align       : center;
    text-transform   : uppercase;
    text-decoration  : none;
    color            : var(--site__color-dark);
    background-color : var(--site__color-hilite);
    padding          : 0.6em 2.4rem 0.5em 2.4rem;
    outline          : transparent;
    border           : transparent;
    cursor           : pointer;
    border-radius    : 0;
    box-shadow       : 0 0 15px 0 #666;
}

button,
.aspbutton:hover,
.promo-button:hover,
.button-container a:hover {
    color            : var(--site__color-light);
    background-color : var(--color5);
}

/** ********************************************* **/
/** TEXT BOX AND COMBO BOX                        **/
/** ********************************************* **/

::selection {
    color            : var(--site__color-light);
    background-color : var(--site__color-hilite);
    opacity          : 1;
}

::placeholder {
    color            : var(--controls__color);
    text-transform   : var(--controls__case);
    opacity          : var(--controls__placeholder-opacity);
    font             : var(--controls__placeholder-font);
}

.textbox, 
.combobox {
    font             : var(--controls__font);
    width            : 100%;
    height           : 2.4em;
    border           : none;
    border-radius    : 0;
    outline          : none;
    padding-left     : 0.8rem;
    color            : var(--controls__color);
    background-color : var(--controls__background-color);
}

.textbox:placeholder-shown,
.combobox:placeholder-shown {
    font             : var(--controls__placeholder-font);
}

.textbox:disabled,
.combobox:disabled {
    background-color : var(--color6);
}

/* Change autofill text in textbox and combobox */
select:-webkit-autofill,
input:-webkit-autofill { 
    font                    : var(--controls__font);
    color                   : var(--controls__color);
    background-color        : var(--controls__background-color);
    -webkit-text-fill-color : var(--controls__placeholder-color);
}

select:-webkit-autofill,
input:-webkit-autofill,
input:-webkit-autofill:hover, 
input:-webkit-autofill:focus, 
input:-webkit-autofill:active {
    transition: background-color 5000s ease-in-out 0s;
}

/** ********************************************* **/
/** COMBO BOX                                     **/
/** ********************************************* **/
 
.combobox {
    -webkit-appearance  : none;
    -moz-appearance     : none;
    appearance          : none;
    
    color               : var(--controls__color);

    background          : var(--controls__background-color) var(--controls__arrowdown) no-repeat right;
    background-size     : var(--controls__arrow-size);
    background-position : var(--controls__arrow-position);

    position            : relative;
    z-index             : 0;
    
    text-indent         : 0.01px; /*In Firefox*/
    text-transform      : var(--controls__case); 
    text-overflow       : ellipsis;
    overflow            : hidden;
    white-space         : nowrap;

    padding-inline-end  : 3em;
}

.combobox:valid {
    font                : var(--controls__font);
}

.combobox:invalid {
    font                : var(--controls__placeholder-font);
}

.combobox:active, 
.combobox:focus {
    background          : var(--controls__background-color) var(--controls__arrowup) no-repeat right;
    background-size     : var(--controls__arrow-size);
    background-position : var(--controls__arrow-position);
}

/*  Apart from font, color and background-color this has little effect  */
.combobox option {
    font                : var(--controls__dropdown-font);
    background-color    : var(--controls__background-color);
}

.combobox option:active {
    font-weight         : 700;
}

.combobox option:first-child {
    color               : var(--site__color-hilite);
    font-weight         : 700;
}

/** ********************************************* **/
/** CHECK BOX                                     **/
/** ********************************************* **/

.checkbox {
    -webkit-appearance  : none;
    -moz-appearance     : none;
    appearance          : none;
    display             : inline-block;
    position            : relative;
    color               : var(--controls__color);
    background-color    : var(--controls__background-color);
    height              : 1.6rem;
    min-width           : 1.6rem;
    cursor              : pointer;
    outline             : transparent;
    border-radius       : var(--controls__border-radius);
}

.checkbox:hover {
    color               : var(--controls__background-color);
    background-color    : var(--site__color-hilite);
}

/* Type 1 */
/*.checkbox:checked {
    border              : 4px solid var(--controls__background-color);
    background-color    :           var(--site__color-hilite);
}

.checkbox:checked:hover {
    border              : 4px solid var(--site__color-hilite);
    background-color    :           var(--controls__background-color);
}*/

.checkbox:checked::before {
    position            : absolute;
    font-size           : 14px;
    font-weight         : 700;
    font-family         : sans-serif;
    left                : 0.5em;
    top                 : 0.15em;
    content             : '\02143';
    transform           : rotate(40deg);
}

/** ********************************************* **/
/** RADIO BUTTONS                                 **/
/** ********************************************* **/

.radio {
    -webkit-appearance        : none;
    -moz-appearance           : none;
    appearance                : none;
    display                   : inline-block;
    position                  : relative;
    color                     : var(--site__color-dark);
    background-color          : var(--site__color-light);
    height                    : 1.6em;
    width                     : 1.6em;
    cursor                    : pointer;
    outline                   : transparent;
    background-color          : var(--controls__background-color);
    border                    : solid 5px transparent;
    border-radius             : 50%;
}

.radio:hover {
    border-color              : var(--controls__color);
    background-color          : var(--controls__background-color);
}

.radio:checked {
    border-color              : var(--controls__background-color);
    background-color          : var(--controls__color);
}

.radio:checked:hover {
    border-color              : var(--controls__color);
    background-color          : var(--controls__color);
}

/** ********************************************* **/
/** UPLOAD CONTROL AND PREVIEW PANEL              **/
/** ********************************************* **/

.upload-panel {
    display                   : block;
    position                  : relative;
    color                     : var(--site__color-dark);
    background                : var(--controls__background-color);
    text-align                : center;
    font-size                 : inherit;
    padding                   : 0;
    border-radius             : var(--controls__border-radius);
}

.upload-button {
    position                  : relative;
    display                   : grid;
    align-content             : start;
    text-align                : center;
    text-transform            : var(--controls__case);
    font                      : var(--controls__font);
    line-height               : 1;
    outline                   : transparent;
    padding                   : 0.5rem 0 0 0;
    box-shadow                : none;
/*  border                    : 2px dashed var(--controls__background-color);  */
    border-start-start-radius : var(--controls__border-radius);
    border-start-end-radius   : var(--controls__border-radius);
    overflow                  : hidden;
    width                     : 100%;
    height                    : 6rem;
    color                     : var(--controls__color);
    background                : transparent var(--controls__upload) no-repeat center 2rem;
    background-size           : var(--controls__upload-size);
    transition: color            .15s ease-in-out,
                background-color .15s ease-in-out,
                border-color     .15s ease-in-out,
                box-shadow       .15s ease-in-out;
}

.upload-control {
    opacity                   : 0;
    position                  : absolute;
    top                       : 0;
    left                      : 0;
    width                     : 100%;
    height                    : 100%;
    cursor                    : pointer;
}

.upload-preview-panel {
    display                   : none;
    max-width                 : 100%;
    transition                : height .3s ease-out;
    height                    : 0;
    overflow                  : hidden;
    background-color          : var(--controls__background-color);
    margin                    : auto !important;
}

.upload-preview-panel img {
    height                    : inherit;
    width                     : 100%;
    margin                    : auto;
}

.upload-label {
    display                   : block;
    text-align                : center;
    font                      : var(--controls__font);
    font-size                 : 0.8em;
    color                     : var(--controls__color);
    background-color          : var(--controls__background-color);
    border-end-start-radius   : var(--controls__border-radius);
    border-end-end-radius     : var(--controls__border-radius);
    padding                   : 0.5rem 2rem 0 2rem;
}

/** ********************************************* **/
/** FOR KEYBOARD NAVIGATION AND ACCESSABILITY     **/
/** ********************************************* **/

      .upload-panel:focus-within,
                  a:focus-visible,
             button:focus-visible,
             select:focus-visible,
             .radio:focus-visible,
           .textbox:focus-visible,
          .checkbox:focus-visible,
         .aspbutton:focus-visible,
      .promo-button:focus-visible,
.button-container a:focus-visible {
    outline                   : 2px solid var(--site__color-hilite);
    outline-offset            : 1px;
}

